$ set symbol /scope=(nolocal,noglobal)	! avoid redefinitions of COPY etc.
$ if p1 .eqs. "LAUNCHED" then -
	goto LAUNCHED
$ if f$mode() .nes. "INTERACTIVE" then -
        exit
$ if f$getjpi( "", "TERMINAL" ) .eqs. "" then -
	exit
$ terminal_width = f$getdvi( f$getjpi( "", "TERMINAL" ), "DEVBUFSIZ" )
$ terminal_ansi = f$getdvi( f$getjpi( "", "TERMINAL" ), "tt_ansicrt" )
$
$ process_n = 0
$ processname := busyclock
$process_again:
$ on error then goto process_increment
$ define/use sys$output nl:
$ define/use sys$error nl:
$ show proc 'processname'
$ goto process_ok
$process_increment:
$ process_n = process_n + 1
$ processname = "BUSYCLOCK''process_n'"
$ goto process_again
$process_ok:
$ spawn/nolog/nowait/input=nl:/proc="Frizzle Fry" -
	@'f$env("procedure")' LAUNCHED 'processname' 'terminal_width' -
	'terminal_ansi' 'p1'
$ write sys$output "[Launching busyclock]"
$ exit
$
$LAUNCHED:
$ processname = p2
$ terminal_width = p3
$ terminal_ansi = p4
$ spawnlatency = p5 .eqs. "SPAWNLATENCY"
$ esc[0,8] = %x1B
$ savecursor = esc + "7"
$ restorecursor = esc + "8"
$ reverse = esc + "[7m"
$ blink = esc + "[5m"
$ normal = esc + "[0m"
$ dummytext = " day dd-mmm-yyyy hh:mm "
$ if spawnlatency then dummytext = dummytext + blink + "000" + " "
$ display_length = f$length( dummytext )
$ column = terminal_width - 1 - display_length
$ toprightcursor = esc + "[1;''column'H"
$ statusline = esc + "[1$}"
$ unstatusline = normal + esc + "[0$}"
$
$ if terminal_ansi then -
	goto do_ansi
$ lead_in = ""
$ bs[0,8] = %x08
$ lead_out = f$fao( "!#*''bs'", display_length )
$ goto done_ansi
$do_ansi:
$ lead_in = savecursor + toprightcursor + statusline + toprightcursor + reverse
$ lead_out = unstatusline + normal + restorecursor
$done_ansi:
$ tmpfile := st$rz:[svvaikun.important.mail]busyclock.tmp
$!SYS$LOGIN:'processname'.tmp
$ open/write file 'tmpfile'
$ dummy = lead_in + dummytext + lead_out
$ write file dummy
$ close file
$ SET FILE /VERSION_LIMIT=1 'tmpfile'
$ convert/fdl=sys$input 'tmpfile' SYS$LOGIN:*.*
RECORD
	CARRIAGE_CONTROL        none
$
$again:
$ display_string = -
   f$extract( 0, 3, f$cvtime( , , "weekday" ) ) -
 + " " -
 + f$edit( f$extract( 0, 17, f$time() ), "trim" )
$ if spawnlatency then gosub spawnlatency
$ gosub center_string
$ file_string = lead_in + display_string + lead_out
$ open/read/write file 'tmpfile'
$ read file dummy
$ write/update file file_string
$ close file
$ copy 'tmpfile' sys$output
$ wait 0:01:00
$ goto again
$! subroutine
$spawnlatency:
$ time = f$cvtime()
$ todays_date = f$element( 0, " ", time )
$ gosub time_to_seconds
$ seconds_before = seconds
$ spawn/nolog /input=nl:
$ time = f$cvtime()
$ gosub time_to_seconds
$ seconds_elapsed = f$fao( "!3SL", seconds - seconds_before )
$ alarm = " "
$ highlight = reverse
$ if seconds_elapsed .gt. 9 then alarm = ""
$ if seconds_elapsed .gt. 9 then highlight = blink
$ display_string = display_string + highlight + seconds_elapsed + alarm
$ return
$!
$time_to_seconds:
$! yyyy-mm-dd hh:mm:ss.00
$ date = f$element( 0, " ", time )
$ time = f$element( 1, " ", time )
$ seconds = f$element( 0, ":", time ) * 3600 -
 + f$element( 1, ":", time ) * 60 -
 + f$element( 0, ".", f$element( 2, ":", time ) )
$ hundreths = seconds * 100 +  + f$element( 1, ".", f$element( 2, ":", time ) )
$ if date .eqs. todays_date then -
	return
$ this_year = 0 + f$element( 0, "-", todays_date )
$ this_month = 0 + f$element( 1, "-", todays_date )
$ this_day = 0 + f$element( 2, "-", todays_date )
$ that_year = 0 + f$element( 0, "-", date )
$ that_month = 0 + f$element( 1, "-", date )
$ that_day = 0 + f$element( 2, "-",  date )
$ days = ( that_year - this_year ) * 365 -
 + ( that_month - this_month ) * 31 -
 + ( that_day - this_day )
$ seconds = 86400 * days + seconds
$ return
$center_string:
$ padding = display_length - f$length( display_string )
$ if padding .gt. 0
$ then
$	leading = padding / 2
$	trailing = padding - leading
$	display_string = f$fao( "!#* !AS!#* ", leading, display_string, trailing )
$ endif
$return
$end:
$ exit
