$!Author : Ram Samudrala
$!	   SVVAIKUN@owucomcn.bitnet .or. SVVAIKUN@cc.owu.edu
$!
$!Usage  : cd [[\]path] [path] [..] [?]
$!cd     : login directory
$!     ? : help
$!     \ : new directory
$!    .. : parent directory
$!
$!Also available Unix like cd.
$!
$ disk_on  = "TRUE"       !Show the disk in the prompt if value is "TRUE."
$ case = "lowercase"	  !displays prompt in lowercase. Change to "upcase"
$			  !if desired.
$!
$ if p1 .eqs. ""  
$ then 
$ set defa sys$login
$ goto done
$ endif
$ s = f$extract(0,1,p1)
$ if s .eqs. "\" then goto newdir
$ if s .eqs. "?" then goto showusage
$ if s .eqs. "." then goto uplevel
$ subdir:
$ gosub parse
$ set def [.'p1']
$ goto done
$!
$ showusage:
$ write sys$output "Usage: cd [\[path]] [path] [..] [?]"
$ goto done
$!
$ logindir:
$ if f$length(p1) .eqs. 1 
$ then set defa sys$login
$ else 
$ gosub parse
$ dir = f$trnlnm("sys$login")
$ dir = f$extract(0,f$length(dir) - 1,dir) + f$extract(1,f$length(p1),p1) + "]"
$ set defa 'dir'
$ endif
$ goto done
$!
$ newdir:
$ p1 = f$extract(1,f$length(p1),p1)
$ if p1 .eqs. "" then set def sys$login
$ gosub parse
$ if p1 .nes. "" then set def ['p1']
$ goto done
$!
$ uplevel:
$ if f$extract(1,1,p1) .eqs. "." then set def [-]
$!
$ done:
$ username = f$trnlnm("sys$login")
$ username = f$extract(f$locate("[",username)+1,f$length(username),username)
$ username = f$extract(0,f$length(username)-1,username)
$ curdir = f$dir()
$ sprompt = ""
$ currdir = f$extract(1,(f$locate("]",curdir)-1),curdir)
$ if currdir .eqs. username then currdir = "\"
$ loop:
$ dot = f$locate(".",currdir) 
$ if dot .eqs. f$length(currdir) then goto prompt
$ sprompt = sprompt + f$extract(0,dot,currdir)  
$ if sprompt .eqs. username 
$ then sprompt = "\" 
$ else sprompt = sprompt + "\"
$ endif
$ currdir = f$extract(dot + 1,f$length(currdir),currdir)
$ goto loop
$ prompt:
$ sprompt = sprompt + currdir
$ if disk_on .eqs. "TRUE" 
$ then
$ curdir = f$parse("","device")
$ sprompt = f$extract(0,f$locate(":",curdir)+1,curdir) + sprompt
$ endif
$ sprompt = f$edit(sprompt,case)
$ set prompt="''sprompt'> "
$!
$ exit:
$ exit
$!
$ parse:
$ location = f$locate("\",p1)
$ if location .eqs. f$length(p1) then goto done_parsing
$ temp = f$extract(location+1,f$length(p1),p1)
$ p1 = f$extract(0,location,p1) + "." + temp
$ goto parse
$ done_parsing:
$ return
