$! Author : Ram Samudrala
$!          svvaikun@cc.owu.edu .or. svvaikun@owucomcn.bitnet
$! 
$! Usage  : mv [i] from-file to-file
$! mv     : rename from-file to to-file
$!     -i : noclobber option
$! 
$ if p1 .eqs. " " .or. p1 .eqs. ""  then goto help
$ p1 = f$extract(1,f$length(p1),p1)
$ p2 = f$extract(f$locate(" ",p1),f$length(p1),p1)
$ p1 = f$extract(0,f$locate(" ",p1),p1)
$ p2 = f$extract(1,f$length(p2),p2)
$ p3 = f$extract(f$locate(" ",p2),f$length(p2),p2)
$ p2 = f$extract(0,f$locate(" ",p2), p2)
$ if p1 .eqs. "-i" then goto i_option
$ if p3 .nes. "" .and. p1 .nes. "-i" then goto help
$ if p2 .eqs. "" then goto help
$ string = f$edit(p1,"trim,collapse")
$ result = ""
$ gosub parse
$ from_file = result
$ if f$search(from_file) .eqs. "" 
$ then
$ write sys$output "''from_file': no such file or directory"
$ exit
$ endif
$ if p2 .eqs. "" then goto help
$ string = f$edit(p2,"trim,collapse")
$ result = ""
$ done = "TRUE"
$ gosub parse
$ to_file = result
$ rename 'from_file' 'to_file'
$ exit
$!
$ i_option:
$ string = f$edit(p2,"trim,collapse")
$ result = ""
$ gosub parse
$ from_file = result
$ if f$search(from_file) .eqs. "" 
$ then
$ write sys$output "''from_file': no such file or directory"
$ exit
$ endif
$ if p3 .eqs. "" then goto help
$ string = f$edit(p3,"trim,collapse")
$ result = ""
$ gosub parse
$ to_file = result
$ if f$search(to_file) .nes. ""
$ then
$ inquire answer "''to_file' already exists, overwrite [y]"
$ if answer .eqs. "N" then $exit
$ endif
$ rename 'from_file' 'to_file'
$ exit
$! 
$ parse:
$ if f$locate("]",string) .nes. f$length(string) then goto vms_done
$ if f$extract(0,1,string) .eqs. "~" then goto add_login_dir
$ if f$locate("/",string) .eqs. f$length(string) then goto vms_done
$ if f$locate(":",string) .nes. f$length(string) then goto add_device
$ if f$extract(0,1,string) .eqs. "/" 
$ then
$ string = f$extract(1,f$length(string),string)
$ result = result + "[000000"
$ if f$locate("/",string) .eqs. f$length(string) 
$ then 
$ result = result + "." + string
$ string = ""
$ endif
$ else
$ result = result + "[."
$ endif
$ parse_1:
$ if f$extract(0,3,string) .eqs. "../" 
$ then
$ if result .eqs. "[." then result = "["
$ result = result + ".-"
$ string = f$extract(3,f$length(string),string)
$ goto parse_1
$ endif
$ if f$locate("/",string) .eqs. f$length(string) then goto done
$ if string .eqs. "" then goto done
$ temp = f$extract(0,f$locate("/",string),string)
$ string = f$extract(f$locate("/",string)+1,f$length(string),string)
$ result = result + "." + temp
$ goto parse_1
$!
$ done:
$ result = result + "]"
$ if string .nes. "" then result = result + string
$ return
$!
$ vms_done:
$ result = string
$ return
$!
$ add_device:
$ device = f$extract(0,f$locate(":",string),string)
$ string = f$extract(f$locate(":",string) + 1,f$length(string),string)
$ result = result + device
$ goto parse_1
$!
$ add_login_dir:
$ login_dir = f$trnlnm("sys$login")
$ login_dir = f$extract(0,f$length(login_dir)-1,login_dir)
$ result = result + login_dir
$ string = f$extract(1,f$length(string),string)
$ if f$extract(0,1,string) .eqs. "/" then - 
  string = f$extract(1,f$length(string),string)
$ goto parse_1
$ exit
$ help:
$ write sys$output "Usage: mv [-i] from-file to-file"
$ exit
