$!Author   : Ram Samudrala
$!	     SVVAIKUN@owucomcn.bitnet .or. SVVAIKUN@cc.owu.edu
$!
$!Usage    : cd [[/]path] [~[path]] [..] [?]
$!cd 	   : login directory
$!       ? : help
$! ~[path] : login directory/path
$! /[path] : new directory
$!      .. : parent directory
$!
$!Set up   : cd :== @disk$[directory]cd """
$!           In your login.com without any thing after the """ quote. i.e. 
$!	     There should be no comments, etc.
$!
$!Features : Does not change to root when you use "cd /" but sets default to 
$!           the login directory. 
$!
$ p1 = f$edit(p1,"collapse")
$ s = f$extract(0,1,p1)
$ if s .eqs. "/" then goto newdir
$ if s .eqs. "?" then goto showusage
$ if s .eqs. "." then goto uplevel
$ if s .eqs. "~" .or. s .eqs. "" then goto logindir
$ subdir:
$ gosub parse 
$ set def [.'p1']
$ goto done
$ showusage:
$ write sys$output "Usage: cd [/[path]] [~[path]] [..] [?]"
$ goto done
$ logindir:
$ if f$length(p1) .eqs. 1 
$ then 
$ set defa sys$login
$ else 
$ dir = f$trnlnm("sys$login")
$ dir = f$extract(0,f$length(dir) - 1,dir) + f$extract(1,f$length(p1),p1) + "]"
$ p1 = dir
$ gosub parse
$ set defa 'p1'
$ endif
$ goto done
$ newdir:
$ p1 = f$extract(1,f$length(p1),p1)
$ if p1 .eqs. "" then set def sys$login
$ gosub parse 
$ if p1 .nes. "" then set def ['p1']
$ goto done
$ uplevel:
$ if f$extract(1,1,p1) .eqs. "." then set def [-]
$ if f$locate("/",p1) .nes. f$length(p1)
$ then
$ p1 = f$extract(f$locate("/",p1), f$length(p1), p1)
$ gosub parse
$ set default ['p1']
$ endif
$ done:
$ curdir = f$dir()
$ currdir = f$extract(1,(f$locate("]",curdir)-1),curdir)
$ currdir = f$edit(currdir,"lowercase")
$ sprompt = ""
$ loop:
$ dot = f$locate(".",currdir) 
$ if dot .eqs. f$length(currdir) then goto prompt
$ sprompt = sprompt + f$extract(0,dot,currdir) + "/"
$ currdir = f$extract(dot + 1,f$length(currdir),currdir)
$ goto loop
$ prompt:
$ sprompt = sprompt + currdir
$ set prompt="''sprompt' %  "
$ exit
$ parse:
$ location = f$locate("/",p1)
$ if location .eqs. f$length(p1) then goto done_parsing
$ temp = f$extract(location+1,f$length(p1),p1)
$ p1 = f$extract(0,location,p1) + "." + temp
$ goto parse
$ done_parsing:
$ return
