$!Author : Ram Samudrala
$!         SVVAIKUN@owucomcn.bitnet .or. SVVAIKUN@cc.owu.edu
$!
$!Bugs    : Any attempt to play around with escape characters in the spawned 
$!	    (second) process could lead to just a lil bit of trouble.
$!
$!define some globals first...
$!
$ dual_location = "@st$rz:[svvaikun.bin]dual"
$ process1 = "So Far, So Good"
$ process2 = "So What?!?!?"
$!
$!commands to help you with dual -- you can define these in your login.com
$!if you so desire, but it would be better if you don't.
$!
$ dswitch 	= "''dual_location' SWITCH"
$ dexit 	= "''dual_location' EXIT"
$ dhelp		= "''dual_location' HELP"
$ dhelp 	:== 'dhelp'
$ ds*witch 	:== 'dswitch'
$ dexit		:== 'dexit'
$!define/key/erase/terminate/nolog enter "dswitch"
$!
$ if p1 .eqs. "" then goto install_dual
$ if f$locate(p1,"EXIT") .eq. 0 then goto dual_exit
$ if f$locate(p1,"HELP") .eq. 0 then goto dual_help
$ if f$locate(p1,"SWITCH") .eq. 0 then goto switch
$ if p1 .nes. "" then goto dual_help
$ install_dual:
$ if f$trnlnm("dual_process1") .eqs. f$process() .or. -
     f$trnlnm("dual_process2") .eqs. f$process() then goto dual_active
$ process=f$process()
$! process1=f$extract(0,13,process)+"_1"
$! process2=f$extract(0,13,process)+"_2"
$ define/nolog dual_process "''process'"
$ define/nolog dual_process1 "''process1'"
$ define/nolog dual_process2 "''process2'"
$ set process/name="''process1'"
$ spawn/nolog/nonotify/wait/input=sys$command/process="''process2'" dswitch
$ write sys$output "[H[2J[1;12r"
$ write sys$output "[Launching DUAL... type DHELP for help]"
$ goto exit
$ switch:
$ new_process=""
$ if f$trnlnm("dual_process1") .eqs. f$process() then -
  new_process=f$trnlnm("dual_process2")
$ if f$trnlnm("dual_process2") .eqs. f$process() then -
  new_process=f$trnlnm("dual_process1")
$ write sys$output "M"
$ if new_process .nes. "" then attach "''new_process'"
$ if new_process .eqs. "" then write sys$output "DUAL not active."
$ if f$trnlnm("dual_process1") .eqs. new_process then write sys$output -
  "M[K[13;24r[22H"
$ if f$trnlnm("dual_process2") .eqs. new_process then write sys$output -
  "M[K[01;12r[10H"
$ goto exit
$ dual_active:
$ write sys$output "DUAL processes are already active."
$ goto exit
$ dual_help:
$ type sys$input

DEXIT   - Exit the DUAL program
DHELP   - Display this help
DSWITCH - Switch between screens
          ENTER key also switches

$ goto exit
$ dual_exit:
$ if f$trnlnm("dual_process2") .eqs. f$process() then goto dual_exit_error
$ if f$trnlnm("dual_process1") .eqs. f$process() then - 
  stop "''f$trnlnm("dual_process2")'"
$ if f$trnlnm("dual_process1") .nes. f$process() then write sys$output -
  "DUAL is not active."
$ set process/name="''f$trnlnm("dual_process")'"
$ write sys$output "[1;24r[24H"
$ goto exit
$ dual_exit_error:
$ write sys$output "[1mYou must EXIT DUAL from the other screen.[0m"
$ exit:
$ exit
